// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package warehouse

import (
	"gitlab.com/uprefer/ustore/base"
	"sync"
)

var (
	lockiDaoMockCreate  sync.RWMutex
	lockiDaoMockDelete  sync.RWMutex
	lockiDaoMockGetAll  sync.RWMutex
	lockiDaoMockGetByID sync.RWMutex
	lockiDaoMockUpdate  sync.RWMutex
)

// Ensure, that iDaoMock does implement iDao.
// If this is not the case, regenerate this file with moq.
var _ iDao = &iDaoMock{}

// iDaoMock is a mock implementation of iDao.
//
//     func TestSomethingThatUsesiDao(t *testing.T) {
//
//         // make and configure a mocked iDao
//         mockediDao := &iDaoMock{
//             CreateFunc: func(m Model) (base.IModel, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(id string) (int, error) {
// 	               panic("mock out the Delete method")
//             },
//             GetAllFunc: func(stared bool) ([]Model, error) {
// 	               panic("mock out the GetAll method")
//             },
//             GetByIDFunc: func(id string) (base.IModel, error) {
// 	               panic("mock out the GetByID method")
//             },
//             UpdateFunc: func(m Model) (base.IModel, error) {
// 	               panic("mock out the Update method")
//             },
//         }
//
//         // use mockediDao in code that requires iDao
//         // and then make assertions.
//
//     }
type iDaoMock struct {
	// CreateFunc mocks the Create method.
	CreateFunc func(m Model) (base.IModel, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(id string) (int, error)

	// GetAllFunc mocks the GetAll method.
	GetAllFunc func(stared bool) ([]Model, error)

	// GetByIDFunc mocks the GetByID method.
	GetByIDFunc func(id string) (base.IModel, error)

	// UpdateFunc mocks the Update method.
	UpdateFunc func(m Model) (base.IModel, error)

	// calls tracks calls to the methods.
	calls struct {
		// Create holds details about calls to the Create method.
		Create []struct {
			// M is the m argument value.
			M Model
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// ID is the id argument value.
			ID string
		}
		// GetAll holds details about calls to the GetAll method.
		GetAll []struct {
			// Stared is the stared argument value.
			Stared bool
		}
		// GetByID holds details about calls to the GetByID method.
		GetByID []struct {
			// ID is the id argument value.
			ID string
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// M is the m argument value.
			M Model
		}
	}
}

// Create calls CreateFunc.
func (mock *iDaoMock) Create(m Model) (base.IModel, error) {
	if mock.CreateFunc == nil {
		panic("iDaoMock.CreateFunc: method is nil but iDao.Create was just called")
	}
	callInfo := struct {
		M Model
	}{
		M: m,
	}
	lockiDaoMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockiDaoMockCreate.Unlock()
	return mock.CreateFunc(m)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockediDao.CreateCalls())
func (mock *iDaoMock) CreateCalls() []struct {
	M Model
} {
	var calls []struct {
		M Model
	}
	lockiDaoMockCreate.RLock()
	calls = mock.calls.Create
	lockiDaoMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *iDaoMock) Delete(id string) (int, error) {
	if mock.DeleteFunc == nil {
		panic("iDaoMock.DeleteFunc: method is nil but iDao.Delete was just called")
	}
	callInfo := struct {
		ID string
	}{
		ID: id,
	}
	lockiDaoMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockiDaoMockDelete.Unlock()
	return mock.DeleteFunc(id)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockediDao.DeleteCalls())
func (mock *iDaoMock) DeleteCalls() []struct {
	ID string
} {
	var calls []struct {
		ID string
	}
	lockiDaoMockDelete.RLock()
	calls = mock.calls.Delete
	lockiDaoMockDelete.RUnlock()
	return calls
}

// GetAll calls GetAllFunc.
func (mock *iDaoMock) GetAll(stared bool) ([]Model, error) {
	if mock.GetAllFunc == nil {
		panic("iDaoMock.GetAllFunc: method is nil but iDao.GetAll was just called")
	}
	callInfo := struct {
		Stared bool
	}{
		Stared: stared,
	}
	lockiDaoMockGetAll.Lock()
	mock.calls.GetAll = append(mock.calls.GetAll, callInfo)
	lockiDaoMockGetAll.Unlock()
	return mock.GetAllFunc(stared)
}

// GetAllCalls gets all the calls that were made to GetAll.
// Check the length with:
//     len(mockediDao.GetAllCalls())
func (mock *iDaoMock) GetAllCalls() []struct {
	Stared bool
} {
	var calls []struct {
		Stared bool
	}
	lockiDaoMockGetAll.RLock()
	calls = mock.calls.GetAll
	lockiDaoMockGetAll.RUnlock()
	return calls
}

// GetByID calls GetByIDFunc.
func (mock *iDaoMock) GetByID(id string) (base.IModel, error) {
	if mock.GetByIDFunc == nil {
		panic("iDaoMock.GetByIDFunc: method is nil but iDao.GetByID was just called")
	}
	callInfo := struct {
		ID string
	}{
		ID: id,
	}
	lockiDaoMockGetByID.Lock()
	mock.calls.GetByID = append(mock.calls.GetByID, callInfo)
	lockiDaoMockGetByID.Unlock()
	return mock.GetByIDFunc(id)
}

// GetByIDCalls gets all the calls that were made to GetByID.
// Check the length with:
//     len(mockediDao.GetByIDCalls())
func (mock *iDaoMock) GetByIDCalls() []struct {
	ID string
} {
	var calls []struct {
		ID string
	}
	lockiDaoMockGetByID.RLock()
	calls = mock.calls.GetByID
	lockiDaoMockGetByID.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *iDaoMock) Update(m Model) (base.IModel, error) {
	if mock.UpdateFunc == nil {
		panic("iDaoMock.UpdateFunc: method is nil but iDao.Update was just called")
	}
	callInfo := struct {
		M Model
	}{
		M: m,
	}
	lockiDaoMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockiDaoMockUpdate.Unlock()
	return mock.UpdateFunc(m)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockediDao.UpdateCalls())
func (mock *iDaoMock) UpdateCalls() []struct {
	M Model
} {
	var calls []struct {
		M Model
	}
	lockiDaoMockUpdate.RLock()
	calls = mock.calls.Update
	lockiDaoMockUpdate.RUnlock()
	return calls
}
